#!/bin/bash

# 此脚本每次开机时运行一次，把显卡驱动添加到initramfs中，避免A卡加载显卡驱动导致的各种问题，如花屏和Xorg报错等

# 检测显卡驱动名称
DRIVER_NAME=$(lspci -k | grep -A 3 -i "vga" | grep "Kernel modules" | awk -F': ' '{print $2}' | sed 's/, /\n/')

if [ "$DRIVER_NAME" = "" ] ; then
    echo "no gpu driver found!"
    exit
fi

# 写入initramfs,下次内核加载显卡驱动更快
if ! grep -q "$DRIVER_NAME" /etc/initramfs-tools/modules; then
    echo "$DRIVER_NAME" >> /etc/initramfs-tools/modules || true
    update-initramfs -uk all || true
fi
